import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * This class is used to create our Grim object in the game
 * 
 * @author
 * @version 1.0
 */
public class Grim extends Fantasma
{
    public int speed = 2; //variable for the speed of the Grim
   
  
   
    /**
     * Act - do whatever the Novia wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        
        //checks if the Grim object intersects a Couraje object
        if(!gotcha(Couraje.class))
          
            hunt(); 
        
          
    }
    /**
     * This method makes the Grim  move in a way that
     * appers  hunting the player
     */
    public void hunt()
    {
         
        List l=getWorld().getObjects(Couraje.class); // a list to save the Couraje object positions
        if (l.size()>0) //we validate if the list is not empty
        {
            Couraje n=(Couraje)l.get(0);
            
             int enx, eny;   
              double angle;
          
             enx=getX()-n.getX(); 
             eny=getY()-n.getY();
            
              angle=Math.toDegrees(Math.atan2(eny,enx))+180;
           
             int x = (int) Math.round(getX() + Math.cos(angle)*speed);
              int y = (int) Math.round(getY()  + Math.sin(angle)*speed);
         
             setLocation(x, y);
        }
       
    }
    
    
    /**
     * This method is used to check if  the Grim object intersects with
     * a Couraje object
     */
    public boolean gotcha(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
    
}