import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font; // Nos sirve para poder escribir
import java.awt.Color; // Nos sirve para exportar los colores 
/**
 * Class wich is used to create a timer 
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */

public class Timer  extends Actor
{
   private int valor = 0; //value = 0;
   private int obj = 0;
    private String text;
    private int sizeString;// stringLength Nos muestra el tamao de la cadena;

    /**
     * Constructor of Timer
     */    
    public Timer()
    {
        this("");
    } 
    
    /**
     * This metod drwas the timer with a specified font and text
     * @param text: the varibale of the text to be written 
     */
    public Timer(String text)
    {
        this.text = text;
        sizeString = (text.length() + 2) * 32;

        setImage(new GreenfootImage(sizeString, 32)); // se obtiene la imagen junto con el ancho y l altura
        Font letra = new Font("Papyrus", 32, 32); // a la clase funete se le pasan los parmetro
        
         GreenfootImage obtimagen = getImage();// se  obtine la imagen en la variable obtimage
        obtimagen.setFont(letra.deriveFont(32.0F));  // Modifica el tamao
        
        obtimagen.setColor(Color.YELLOW);// Se pon el color
        
        actualizaImagen();
    }
 
    
    public void act() {
        if(valor < obj) {
            valor++;
            actualizaImagen();
        }
        else if(valor > obj) {
            valor--;
            actualizaImagen();
        }
    }
  /**
   * This metod increases time
   * @param tam: the amount of time ot be increased
   */
   public void add(int tam) // va incrementando el tiempo
    {
        obj += tam;
    }

    /**
     * Decreases time
     * @param tam: the amount of time to be decreased
     */
    public void subtract(int tam) // se va disminullento el tiempo
    {
        obj-= tam;
    }

    /**
     * Retunr the current value of the timer
     */
    public int getValor()
    {
        int tmpVal=valor;
        return tmpVal;
    }
    
    /**
     * Update the clock, draw the current clock with the time updated
     */
        private void actualizaImagen()
    {
        GreenfootImage imagenText = getImage(); // se obtiene la imgen de texto
        imagenText.clear();//Se limpia el texto que ahi actualmente
        imagenText.drawString(text + valor, 1, 32);// Se pone en la misma posicion dibuja el texto
        imagenText.setColor(Color.YELLOW); // para finalizar pone el color de la letra
    }
   
}